(*
Copyright 2011 Christian Sternagel, René Thiemann

This file is part of IsaFoR/CeTA.

IsaFoR/CeTA is free software: you can redistribute it and/or modify it under the
terms of the GNU Lesser General Public License as published by the Free Software
Foundation, either version 3 of the License, or (at your option) any later
version.

IsaFoR/CeTA is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along
with IsaFoR/CeTA. If not, see <http://www.gnu.org/licenses/>.
*)
theory Dual_Multiset_Impl
imports 
  List_Order_Impl
  Dual_Multiset
begin

definition dms_order_ext :: "nat \<Rightarrow> 'a list_ext_impl" where 
  "dms_order_ext n S_NS as bs \<equiv> let S = {(a,b). fst (S_NS a b)}; NS = {(a,b). snd (S_NS a b)}
       in ((as,bs) \<in> dms_order n True S NS, (as,bs) \<in> dms_order n False S NS)"

(* TODO: write executable version of dms_order_ext *)

lemma dms_order_ext_list_ext: "\<exists> s ns. list_order_extension_impl s ns (dms_order_ext n)"
proof(intro exI)
  let ?s = "dms_order n True"
  let ?ns = "dms_order n False"
  let ?o = "dms_order_ext n"
  show "list_order_extension_impl ?s ?ns ?o"
  proof
    fix s ns
    show "?s {(a,b). s a b} {(a,b). ns a b} = {(as,bs). fst (?o (\<lambda> a b. (s a b, ns a b)) as bs)}" unfolding dms_order_ext_def Let_def by auto
  next
    fix s ns
    show "?ns {(a,b). s a b} {(a,b). ns a b} = {(as,bs). snd (?o (\<lambda> a b. (s a b, ns a b)) as bs)}" unfolding dms_order_ext_def Let_def by auto
  next
    fix s ns s' ns' as bs
    assume "set as \<times> set bs \<inter> ns \<subseteq> ns'"
           "set as \<times> set bs \<inter> s \<subseteq> s'"
           "(as,bs) \<in> ?s s ns"
    thus "(as,bs) \<in> ?s s' ns'" by (rule dms_order_mono)
  next
    fix s ns s' ns' as bs
    assume "set as \<times> set bs \<inter> ns \<subseteq> ns'"
           "set as \<times> set bs \<inter> s \<subseteq> s'"
           "(as,bs) \<in> ?ns s ns"
    thus "(as,bs) \<in> ?ns s' ns'" by (rule dms_order_mono)
  qed
qed
  
end