import scala.io.Source
import Ceta._

object Main {
  def main(args : Array[String]) {
    if (args.length == 1) {
      start(false, Source.fromFile(args(0)).toList)
    } else if (args.length == 2) {
      if (args(0) == "--allow-assumptions")
        start(true, Source.fromFile(args(1)).toList)
        else error("flag '" + args(0) + "' not supported")
    } else {
      error("usage: ceta [--allow-assumptions] problemFile.xml(in cpf-format)     (CeTA version 2.1)")
    }
  }

  def start(a : Boolean, input : List[Char]) = certify_proof(a, input) match {
    case Certified(prf) => print("CERTIFIED " + prf.mkString + "\n")
    case Unsupported(msg) => error("UNSUPPORTED\n" + msg.mkString + "\n")
    case Error(msg) => error("REJECTED\n" + msg.mkString + "\n")
  }
}
